using System.Runtime.Serialization;
using System.Text.Json.Serialization;
using ESCPOS_NET.Emitters;

public class Barcode2D : BaseInstruction
{
    [DataMember(IsRequired = true)]
    public string? data { get; set; }

    [JsonConverter(typeof(JsonStringEnumConverter))]
    public TwoDimensionCodeType barcodeType {get; set; } = TwoDimensionCodeType.PDF417;

    [JsonConverter(typeof(JsonStringEnumConverter))]
    public Size2DCode size {get; set; } = Size2DCode.NORMAL;

    [JsonConverter(typeof(JsonStringEnumConverter))]
    public CorrectionLevel2DCode correctionLevel {get; set; } = CorrectionLevel2DCode.PERCENT_7;

    public override List<byte[]> GetInstructions()
    {
        var commands = new List<byte[]>();

        commands.Add(e.Print2DCode(barcodeType,data,size,correctionLevel));

        return commands;
    }
}
